/***************************************************************************
 *                                                                         *
 *    NoMoRe++                                                             *
 *                                                                         *
 *    Copyright (C) 2003-2005 NoMoRe Developing Group                      *
 *                                                                         * 
 *    For more information, see http://www.cs.uni-potsdam.de/nomore/       *
 *    or email to nomore-dg@cs.uni-potsdam.de                              *
 *                                                                         *
 *                                                                         *
 *    This program is free software; you can redistribute it and/or        *
 *    modify it under the terms of the GNU General Public License          *
 *    as published by the Free Software Foundation; either version 2       *
 *    of the License, or (at your option) any later version.               *
 *                                                                         *
 *    This program is distributed in the hope that it will be useful,      *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *    GNU General Public License for more details.                         *
 *                                                                         *
 *    You should have received a copy of the GNU General Public License    *
 *                                                                         * 
 ***************************************************************************/

#ifndef LIBNOMORE_GRAPH_CLONER_H
#define LIBNOMORE_GRAPH_CLONER_H
#if defined (_MSC_VER) && _MSC_VER <= 1300
#pragma warning (disable : 4786)
#endif

#include <graph.h>
#include <memory>


namespace NS_NOMORE {

class GraphCloner
{
public:
  GraphCloner();
  ~GraphCloner();
  Graph* clone(const Graph& toClone);
private:
  void reset();
  void initToClone(const Graph& toClone);
  Node* insertCorresponding(Node* original);
  
  typedef std::pair<Node*, Node*> NodePair;
  
  inline void addSuccessors(const NodePair& n);
  void addSuccessors(HeadNode* original, HeadNode* clone);
  void addSuccessors(BodyNode* original, BodyNode* clone);
  
  std::auto_ptr<Graph> theClone_;

  const Graph* toClone_;
  
  std::vector<NodePair> clonedNodes_;
};

}


#endif
